import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'flutter_tool_android_method_channel.dart';

abstract class FlutterToolAndroidPlatform extends PlatformInterface {
  /// Constructs a FlutterToolAndroidPlatform.
  FlutterToolAndroidPlatform() : super(token: _token);

  static final Object _token = Object();

  static FlutterToolAndroidPlatform _instance =
      MethodChannelFlutterToolAndroid();

  /// The default instance of [FlutterToolAndroidPlatform] to use.
  ///
  /// Defaults to [MethodChannelFlutterToolAndroid].
  static FlutterToolAndroidPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [FlutterToolAndroidPlatform] when
  /// they register themselves.
  static set instance(FlutterToolAndroidPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<bool> isIgnoringBatteryOptimizations() {
    throw UnimplementedError(
        'isIgnoringBatteryOptimizations() has not been implemented.');
  }

  Future<void> openBatteryOptimizationSettings() {
    throw UnimplementedError(
        'openBatteryOptimizationSettings() has not been implemented.');
  }

  Future<void> openAppBackgroundSetting() {
    throw UnimplementedError(
        'openAppBackgroundSetting() has not been implemented.');
  }

  Future<void> backHome() {
    throw UnimplementedError('backHome() has not been implemented.');
  }
}
